<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: TR_Chofer.xml */
/* Generado: 2021-09-09 16:55:24 */

/* Mantenimiento de los registros de la tabla TR_Chofer */
abstract class BaseTR_ChoferDP extends TR_ChoferBV
{
    /* Constructor ( Establece los valores desde un objeto TR_ChoferBN ) */
    public function __construct( TR_ChoferBN $o_TR_ChoferBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_TR_ChoferBN ) )
        {
            $this->setByBN( $o_TR_ChoferBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto TR_ChoferBN */
    public function setByBN( TR_ChoferBN $o_TR_ChoferBN )
    {
        if ( !is_null( $o_TR_ChoferBN->getIdChofer() ) )
        {
            $this->setIdChofer( $o_TR_ChoferBN->getIdChofer() );
        }
        if ( !is_null( $o_TR_ChoferBN->getIdCompania() ) )
        {
            $this->setIdCompania( $o_TR_ChoferBN->getIdCompania() );
        }
        if ( !is_null( $o_TR_ChoferBN->getIdSucursal() ) )
        {
            $this->setIdSucursal( $o_TR_ChoferBN->getIdSucursal() );
        }
        if ( !is_null( $o_TR_ChoferBN->getChoferDocumento() ) )
        {
            $this->setChoferDocumento( $o_TR_ChoferBN->getChoferDocumento() );
        }
        if ( !is_null( $o_TR_ChoferBN->getChoferApellidoP() ) )
        {
            $this->setChoferApellidoP( $o_TR_ChoferBN->getChoferApellidoP() );
        }
        if ( !is_null( $o_TR_ChoferBN->getChoferApellidoM() ) )
        {
            $this->setChoferApellidoM( $o_TR_ChoferBN->getChoferApellidoM() );
        }
        if ( !is_null( $o_TR_ChoferBN->getChoferNombre() ) )
        {
            $this->setChoferNombre( $o_TR_ChoferBN->getChoferNombre() );
        }
        if ( !is_null( $o_TR_ChoferBN->getChoferTelefono() ) )
        {
            $this->setChoferTelefono( $o_TR_ChoferBN->getChoferTelefono() );
        }
        if ( !is_null( $o_TR_ChoferBN->getChoferLicencia() ) )
        {
            $this->setChoferLicencia( $o_TR_ChoferBN->getChoferLicencia() );
        }
        if ( !is_null( $o_TR_ChoferBN->getChoferCategoria() ) )
        {
            $this->setChoferCategoria( $o_TR_ChoferBN->getChoferCategoria() );
        }
        if ( !is_null( $o_TR_ChoferBN->getChoferDireccion() ) )
        {
            $this->setChoferDireccion( $o_TR_ChoferBN->getChoferDireccion() );
        }
        if ( !is_null( $o_TR_ChoferBN->getChoferUbigeo() ) )
        {
            $this->setChoferUbigeo( $o_TR_ChoferBN->getChoferUbigeo() );
        }
        if ( !is_null( $o_TR_ChoferBN->getChoferAyudante() ) )
        {
            $this->setChoferAyudante( $o_TR_ChoferBN->getChoferAyudante() );
        }
        if ( !is_null( $o_TR_ChoferBN->getEstado() ) )
        {
            $this->setEstado( $o_TR_ChoferBN->getEstado() );
        }
        if ( !is_null( $o_TR_ChoferBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_TR_ChoferBN->getFechaCreacion() );
        }
        if ( !is_null( $o_TR_ChoferBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_TR_ChoferBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_TR_ChoferBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_TR_ChoferBN->getFechaModificacion() );
        }
        if ( !is_null( $o_TR_ChoferBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_TR_ChoferBN->getUsuarioModificacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_TR_ChoferFN = new TR_ChoferFN();
        $o_TR_ChoferBN = $o_TR_ChoferFN->selectByPk( $this->getIdChofer() );
        if ( is_null( $o_TR_ChoferBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO TR_Chofer ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getIdChofer() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdChofer";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdChofer()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdCompania() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdCompania";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdCompania()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdSucursal() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdSucursal";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdSucursal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getChoferDocumento() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ChoferDocumento";
                $s_SQLQuery2 .= $s_Separator."'".$this->getChoferDocumento()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getChoferApellidoP() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ChoferApellidoP";
                $s_SQLQuery2 .= $s_Separator."'".$this->getChoferApellidoP()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getChoferApellidoM() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ChoferApellidoM";
                $s_SQLQuery2 .= $s_Separator."'".$this->getChoferApellidoM()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getChoferNombre() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ChoferNombre";
                $s_SQLQuery2 .= $s_Separator."'".$this->getChoferNombre()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getChoferTelefono() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ChoferTelefono";
                $s_SQLQuery2 .= $s_Separator."'".$this->getChoferTelefono()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getChoferLicencia() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ChoferLicencia";
                $s_SQLQuery2 .= $s_Separator."'".$this->getChoferLicencia()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getChoferCategoria() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ChoferCategoria";
                $s_SQLQuery2 .= $s_Separator."'".$this->getChoferCategoria()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getChoferDireccion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ChoferDireccion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getChoferDireccion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getChoferUbigeo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ChoferUbigeo";
                $s_SQLQuery2 .= $s_Separator."'".$this->getChoferUbigeo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getChoferAyudante() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ChoferAyudante";
                $s_SQLQuery2 .= $s_Separator."'".$this->getChoferAyudante()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Estado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE TR_Chofer SET ";
            $s_Separator = "";
            if ( !is_null( $this->getIdCompania() ) )
            {
                $s_SQLQuery .= $s_Separator."IdCompania = ".$this->getIdCompania()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdSucursal() ) )
            {
                $s_SQLQuery .= $s_Separator."IdSucursal = ".$this->getIdSucursal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getChoferDocumento() ) )
            {
                $s_SQLQuery .= $s_Separator."ChoferDocumento = '".$this->getChoferDocumento()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getChoferApellidoP() ) )
            {
                $s_SQLQuery .= $s_Separator."ChoferApellidoP = '".$this->getChoferApellidoP()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getChoferApellidoM() ) )
            {
                $s_SQLQuery .= $s_Separator."ChoferApellidoM = '".$this->getChoferApellidoM()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getChoferNombre() ) )
            {
                $s_SQLQuery .= $s_Separator."ChoferNombre = '".$this->getChoferNombre()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getChoferTelefono() ) )
            {
                $s_SQLQuery .= $s_Separator."ChoferTelefono = '".$this->getChoferTelefono()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getChoferLicencia() ) )
            {
                $s_SQLQuery .= $s_Separator."ChoferLicencia = '".$this->getChoferLicencia()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getChoferCategoria() ) )
            {
                $s_SQLQuery .= $s_Separator."ChoferCategoria = '".$this->getChoferCategoria()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getChoferDireccion() ) )
            {
                $s_SQLQuery .= $s_Separator."ChoferDireccion = '".$this->getChoferDireccion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getChoferUbigeo() ) )
            {
                $s_SQLQuery .= $s_Separator."ChoferUbigeo = '".$this->getChoferUbigeo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getChoferAyudante() ) )
            {
                $s_SQLQuery .= $s_Separator."ChoferAyudante = '".$this->getChoferAyudante()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery .= $s_Separator."Estado = '".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaModificacion = '".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioModificacion = '".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  IdChofer = ".$this->getIdChofer().";";
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM TR_Chofer WHERE  IdChofer = ".$this->getIdChofer().";";
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        return true;
    }

}
?>